package fi.er.formPlugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.TimeUnit;

public class TripreimbursePlugin extends AbstractFormPlugin implements Plugin {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String fieldKey = e.getProperty().getName();
        if (StringUtils.equals("nckd_amountfield1", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            BigDecimal newAmount = (BigDecimal) changeData.getNewValue();
            BigDecimal oldAmount = (BigDecimal) changeData.getOldValue();
            BigDecimal amount = newAmount.subtract(oldAmount);
            DynamicObjectCollection entryentity = this.getModel().getEntryEntity("entryentity");
            for (int i = 0; i < entryentity.size(); i++) {
                if (entryentity.get(i).getDynamicObject("expenseitem").getString("number").equals("009")) {
                    BigDecimal orientryamount = (BigDecimal) this.getModel().getValue("orientryamount", i);
                    orientryamount = orientryamount.add(amount);
                    this.getModel().setValue("orientryamount", orientryamount, i);
                }
            }
        }else if (StringUtils.equals("nckd_daterangefield_enddate", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            Date nckd_daterangefield_enddate = (Date) changeData.getNewValue();
            if (nckd_daterangefield_enddate == null) {
                this.getModel().setValue("nckd_amountfield2", null);
            }else {
                Date nckd_daterangefield_startdate = (Date) this.getModel().getValue("nckd_daterangefield_startdate");
                SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmmss");
                long differenceInMillies = nckd_daterangefield_enddate.getTime() - nckd_daterangefield_startdate.getTime();
                long hoursDifference = TimeUnit.MILLISECONDS.toHours(differenceInMillies);
                // 基础补助金额
                long baseSubsidy = 60;
                // 超过每小时补助10元
                long additionalSubsidy = 10;
                // 计算总补助
                long totalSubsidy = 0;
                if (hoursDifference >=  5) {
                    totalSubsidy = baseSubsidy;
                    // 计算超过5小时的部分
                    long extraHours = hoursDifference - 5;
                    totalSubsidy += additionalSubsidy * extraHours;
                }
                BigDecimal newAmount = BigDecimal.valueOf(totalSubsidy);
                BigDecimal oldAmount = (BigDecimal) this.getModel().getValue("nckd_amountfield2") == null ? BigDecimal.ZERO : (BigDecimal) this.getModel().getValue("nckd_amountfield2");
                BigDecimal amount = newAmount.subtract(oldAmount);
                DynamicObjectCollection entryentity = this.getModel().getEntryEntity("entryentity");
                for (int i = 0; i < entryentity.size(); i++) {
                    if (entryentity.get(i).getDynamicObject("expenseitem").getString("number").equals("009")) {
                        BigDecimal orientryamount = (BigDecimal) this.getModel().getValue("orientryamount", i);
                        orientryamount = orientryamount.add(amount);
                        this.getModel().setValue("orientryamount", orientryamount, i);
                    }
                }
                this.getModel().setValue("nckd_amountfield2", newAmount);
            }
        }else if (StringUtils.equals("nckd_checkboxfield1", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            boolean nckd_checkboxfield1 = (boolean) changeData.getNewValue();
            if (!nckd_checkboxfield1) {
                this.getModel().setValue("nckd_amountfield1", BigDecimal.ZERO);
            }
        }else if (StringUtils.equals("nckd_checkboxfield2", fieldKey)) {
            ChangeData changeData = e.getChangeSet()[0];
            boolean nckd_checkboxfield2 = (boolean) changeData.getNewValue();
            if (!nckd_checkboxfield2) {
                BigDecimal nckd_amountfield2 = (BigDecimal) this.getModel().getValue("nckd_amountfield2");
                DynamicObjectCollection entryentity = this.getModel().getEntryEntity("entryentity");
                for (int i = 0; i < entryentity.size(); i++) {
                    if (entryentity.get(i).getDynamicObject("expenseitem").getString("number").equals("009")) {
                        BigDecimal orientryamount = (BigDecimal) this.getModel().getValue("orientryamount", i);
                        orientryamount = orientryamount.subtract(nckd_amountfield2);
                        this.getModel().setValue("orientryamount", orientryamount, i);
                    }
                }
                this.getModel().setValue("nckd_amountfield2", BigDecimal.ZERO);
                this.getModel().setValue("nckd_daterangefield_startdate", null);
                this.getModel().setValue("nckd_daterangefield_enddate", null);
            }
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        String operateKey = e.getOperateKey();
        if ("nckd_copy".equals(e.getOperateKey())) {
            EntryGrid entryGrid = this.getControl("nckd_invoiceandexpense");
            int[] selectRows = entryGrid.getSelectRows();
            if (selectRows.length > 0) {
                int index = selectRows[0];
                DynamicObjectCollection nckd_invoiceandexpense = this.getModel().getEntryEntity("nckd_invoiceandexpense");
                DynamicObject entry = nckd_invoiceandexpense.get(index);
                DynamicObject nckd_basedatafield = entry.getDynamicObject("nckd_basedatafield");
                DynamicObject nckd_basedatafield1 = entry.getDynamicObject("nckd_basedatafield1");
                BigDecimal nckd_decimalfield = entry.getBigDecimal("nckd_decimalfield");
                BigDecimal nckd_amountfield3 = entry.getBigDecimal("nckd_amountfield3");
                int rowIndex = this.getModel().createNewEntryRow("nckd_invoiceandexpense");
                this.getModel().setValue("nckd_basedatafield", nckd_basedatafield, rowIndex);
                this.getModel().setValue("nckd_basedatafield1", nckd_basedatafield1, rowIndex);
                this.getModel().setValue("nckd_decimalfield", nckd_decimalfield, rowIndex);
                this.getModel().setValue("nckd_amountfield3", nckd_amountfield3, rowIndex);
                this.getView().updateView("nckd_invoiceandexpense");
            }
        }
    }
}
